Attribute VB_Name = "modMain"
Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Public Declare Function apiGetSystemDirectory Lib "kernel32" Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Public Declare Sub MoveMemory Lib "kernel32" Alias "RtlMoveMemory" (pDest As Any, pSource As Any, ByVal dwLength As Long)

Public Declare Function SHGetSpecialFolderPath Lib "shell32" Alias "SHGetSpecialFolderPathA" (ByVal hwndOwner As Long, ByVal pszPath As String, ByVal nFolder As Long, ByVal fCreate As Boolean) As Long
Public Declare Function SHGetSpecialFolderLocation Lib "shell32.dll" (ByVal hwndOwner As Long, ByVal nFolder As Long, pidl As Long) As Long
Public Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath As String) As Long
Public Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal pv As Long)
Public Const NOERROR = 0
Public Const MAX_PATH = 260
Public Const CSIDL_DESKTOPDIRECTORY = &H10

Public Declare Function SendMessage Lib "USER32.DLL" Alias "SendMessageA" (ByVal hwnd As Long, ByVal dwMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Const EM_UNDO = &HC7
Private Const WM_CUT = &H300
Private Const WM_COPY = &H301
Private Const WM_PASTE = &H302
Private Const WM_CLEAR = &H303
Private Const WM_UNDO = &H304


Global DLLFILE As String
Global CompileDLL As Object
Global DLLLoaded As Boolean

Public Function AppPath() As String
'This gets the app's path
If Right(App.Path, 1) = "\" Then AppPath = App.Path Else AppPath = App.Path & "\"
End Function

Public Sub InitDLLs()
    On Error Resume Next
    
    Dim Error As Boolean
    Dim dllPath As String, dllsNotFound As String
    
    Dim dllName1 As String
    Dim dllName2 As String
    
    dllName1 = "\DPPAPP.dll"
    dllName2 = "\DPPSecurity.dll"
    
    '----- dllName1
    If FileExist(GetSystemDirectory & dllName1) Then 'check system folder
        DLLFILE = GetSystemDirectory & dllName1
    ElseIf FileExist(AppPath & dllName1) Then 'check current directory
        DLLFILE = AppPath & dllName1
    Else 'can't find it!
        dllsNotFound = dllName1
        DLLFILE = "-1"
    End If
    
    '----- dllName2
Start:
    On Error GoTo nodll
    
    If FileExist(GetSystemDirectory() & dllName2) Then
        dllPath = GetSystemDirectory() & dllName2
    ElseIf FileExist(AppPath & dllName2) Then
        dllPath = AppPath & dllName2
        FileCopy dllPath, GetSystemDirectory() & dllName2
    Else
        dllsNotFound = dllsNotFound & vbCrLf & dllName2
        Set CompileDLL = Nothing
        DLLLoaded = False
        GoTo finish
    End If
    
    Set CompileDLL = CreateObject("DPPSecurity.DPPCompiler")
        
    If CompileDLL.initializedll() <> "D++ Compiler Ready" Then
        MsgBox "The DPPSecurity DLL has been tampered with, is corrupted, is out of date, or is not the correct DLL.", vbExclamation, "D++ Error"
        dllsNotFound = dllsNotFound & vbCrLf & dllName2
        Set CompileDLL = Nothing
        DLLLoaded = False
        GoTo finish
    End If
        
    DLLLoaded = True
        
    GoTo finish
        
nodll:
    If Error Then
        MsgBox "There was an error loading '" & dllName2 & "': ActiveX Component could not create object.", vbCritical, "D++ Error"
        dllsNotFound = dllsNotFound & dllName2
        DLLLoaded = False
    Else
        Error = True
        Shell "regsvr32 dppsecurity.dll /s" 'register DLL silently
        DoEvents
        GoTo Start
    End If
    
finish:
If dllsNotFound <> "" Then _
    MsgBox "D++ SDE could not locate or was unable to load the following required files:" & vbCrLf & vbCrLf & dllsNotFound & vbCrLf & vbCrLf & "You will not be able to compile or run your projects.", vbExclamation, "D++ Error"
End Sub

Sub UninitDLL()
    Set CompileDLL = Nothing
    DLLLoaded = False
End Sub

Sub Pause(interval)
    'pause execution
    Current = Timer
    Do While Timer - Current < Val(interval)
        DoEvents
    Loop
End Sub

Public Function GetDesktopDirectory(hwnd As Long)
    'This function gets the desktop directory
    On Error GoTo NotExported
    Dim pidl As Long, sPath As String * MAX_PATH, nFolder As Long
    
    nFolder = CSIDL_DESKTOPDIRECTORY
    Call SHGetSpecialFolderPath(hwnd, sPath, nFolder, 0)
    If InStr(sPath, vbNullChar) > 1 Then
        GetDesktopDirectory = Left$(sPath, InStr(sPath, vbNullChar) - 1)
        Exit Function
    End If
    
NotExported:
    If SHGetSpecialFolderLocation(hwnd, nFolder, pidl) = NOERROR Then
        If pidl Then
            If SHGetPathFromIDList(pidl, sPath) Then
                GetDesktopDirectory = Left$(sPath, InStr(sPath, vbNullChar) - 1)
            End If
            Call CoTaskMemFree(pidl)
        End If
    End If
End Function

Public Function GetSystemDirectory() As String
    Dim strBuffer As String, lngReturn As String
    strBuffer = Space(255)
    lngReturn = apiGetSystemDirectory(strBuffer, Len(strBuffer))
    GetSystemDirectory = Left(strBuffer, lngReturn)
End Function

Sub AddDebug(TextToAdd As String)
    'adds text to the debug box
    frmMain.txtDebug.Text = frmMain.txtDebug.Text & TextToAdd & vbCrLf
End Sub

Public Function FileExist(ByVal fileName As String) As Boolean
    'Determines if a file exists
    On Error Resume Next
    If Dir(fileName, vbSystem + vbHidden) = "" Then
        FileExist = False
    Else
        FileExist = True
    End If
End Function

Function ReadFile(ByVal sFileName As String) As String
    'reads a file
    Dim fhFile As Integer
    fhFile = FreeFile
    Open sFileName For Binary As #fhFile
    ReadFile = Input$(LOF(fhFile), fhFile)
    Close #fhFile
End Function

Public Function GetFileName(FullPath As String) As String
    'This parses a full path to get the file name
    On Error Resume Next
    
    
    For i = Len(FullPath) To 1 Step -1
        sChar = Mid(FullPath, i, 1)
        If sChar = "\" Then
            GetFileName = StrReverse(GetFileName)
            Exit For
        End If
        GetFileName = GetFileName & sChar
    Next i
End Function

Public Function GetExtension(FullPath As String) As String
    'This parses a full path to get the file name
    On Error Resume Next
    
    For i = Len(FullPath) To 1 Step -1
        sChar = Mid(FullPath, i, 1)
        If sChar = "." Then
            GetExtension = StrReverse(GetExtension)
            Exit For
        End If
        GetExtension = GetExtension & sChar
    Next i
End Function

Function Crypt(Text) As String
    'a simple crypter
    For i = 1 To Len(Text)
        DoEvents
        Crypt = Crypt & Chr(255 - Asc(Mid(Text, i, 1)))
    Next i
End Function

Public Sub LaunchURL(URL As String)
    On Error Resume Next
    ret = MsgBox("Launch your web browser and navigate to this page?" & vbCrLf & vbCrLf & "   --> " & URL, vbInformation + vbYesNo, "Launch URL")
    If ret = vbYes Then _
        ShellExecute frmMain.hwnd, "Open", URL, 0, 0, 1
End Sub

Public Function BrowseCallbackProcStr(ByVal hwnd As Long, ByVal uMsg As Long, ByVal lParam As Long, ByVal lpData As Long) As Long
    If uMsg = 1 Then
        Call SendMessage(hwnd, BFFM_SETSELECTIONA, True, ByVal lpData)
    End If
End Function

Public Function FunctionPointer(FunctionAddress As Long) As Long
    FunctionPointer = FunctionAddress
End Function


Public Sub Run(UseDOS As Boolean)
'On Error GoTo Errorh
Dim APPFILE As String

APPFILE = GetSetting("D++", "Options", "RunAt") & "\D++APP1.EXE"

CompileFile APPFILE, True, UseDOS

SaveSetting "D++", "Memory", "Run", APPFILE
    
Exit Sub
    
Errorh:
If Err.Number = 0 Then Exit Sub
AddDebug ">Compile Error " & Err.Number & ": " & Err.Description
AddDebug ">D++ Application Terminated"
End Sub

Public Sub MakeEXE(UseDOS As Boolean)
On Error GoTo Errorh
Dim APPFILE As String

frmMain.CommonDialog1.Filter = "EXE Files (*.exe)|*.exe|All Files (*.*)|*.*"
frmMain.CommonDialog1.DialogTitle = "Compile D++ File"
frmMain.CommonDialog1.CancelError = True
frmMain.CommonDialog1.ShowSave

APPFILE = frmMain.CommonDialog1.fileName

If FileExist(APPFILE) Then
    Overwrite = MsgBox("A file already exists by this name.  Overwrite?", 276, "File Found!")
    If Overwrite = 6 Then
        AddDebug ">EXE overwritten"
    Else
        AddDebug ">Canceled by user"
        AddDebug ">D++ Application Terminated"
        Exit Sub
    End If
End If

CompileFile APPFILE, False, UseDOS

SaveSetting "D++", "Memory", "Compile", APPFILE

Exit Sub

Errorh:
If Err.Number = 32755 Then
    AddDebug ">Canceled compile."
    Exit Sub
End If
AddDebug ">Compile Error " & Err.Number & ": " & Err.Description
AddDebug ">D++ Application Terminated"
End Sub

Public Sub CompileFile(FilePath As String, Link As Boolean, UseDOS As Boolean)
'Compiles the DLL file (blank app with code) using DPPSecurity.DPPCompiler
Dim StartTime As Single
Dim SourceCode As String
Dim NewDebug As String
Dim Error As Boolean

'Check if DLL is installed:
tryagain:
If Not DLLLoaded Or DLLFILE = "-1" Then
    If Not Error Then
        InitDLLs
        Error = True
        GoTo tryagain
    Else
        MsgBox "Cannot compile project. One or more of the required files for D++ could not be found or have not been loaded.", vbCritical, "Error"
        AddDebug ">Compile aborted: DLL(s) do not exist/are not loaded."
        AddDebug ">D++ Application Terminated"
        Exit Sub
    End If
End If

StartTime = GetTickCount 'Set start time
If Header = "" Then Header = "DPP:" 'make sure there's a header
SourceCode = frmMain.txtText.Text 'Get Source Code

AddDebug ">Executing DPPSecurity.DPPCompiler ..."
NewDebug = CompileDLL.CompileFile(FilePath, Link, UseDOS, StartTime, SourceCode, DLLFILE)
AddDebug NewDebug
frmMain.txtDebug.Text = Left(frmMain.txtDebug.Text, Len(frmMain.txtDebug.Text) - 2)

'If Mid(frmMain.txtDebug.Text, Len(frmMain.txtDebug.Text) - 1, 2) = vbCrLf Then
'    frmMain.txtDebug.Text = Mid(frmMain.txtDebug.Text, 1, Len(frmMain.txtDebug.Text) - 2)
'End If

frmMain.txtDebug.selStart = Len(frmMain.txtDebug.Text)
End Sub

Public Function ReadEXE(sPath As String) As String
'Reads an EXE file and gets D++ source
On Error GoTo Error
Dim FileData As String, Header As String
Dim compileOpt1 As String, compileOpt2 As String, compileOpt3 As String
    
FileData = ReadFile(sPath)

If InStr(1, FileData, "dppapp:") = 0 Or InStr(1, FileData, "dpp:") = 0 Then
    If InStr(1, FileData, "DPP:$D2>:") = 0 Then
        ReadEXE = "'Note: No source code found."
        Exit Function
    Else
        ReadEXE = "'Note: This application was compiled in a " & vbCrLf & "'previous version of the D++ compiler." & vbCrLf & vbCrLf
        ReadEXE = ReadEXE & Crypt(Mid(FileData, InStr(1, FileData, "DPP:$D2>:") + 9))
        Exit Function
    End If
End If

Header = LCase(Mid(FileData, InStr(1, FileData, "dppapp:"), 35))
compileOpt1 = Mid(Header, 13, 3)
compileOpt2 = Mid(Header, 23, 1)
compileOpt3 = Mid(Header, 30, 1)

Select Case compileOpt1
    Case "dos", "dpp"
        'don't do anything, it's good
    Case "reg"
        ReadEXE = "'Note: This is a temporary EXE.  It does not contain source."
        Exit Function
    Case Else
        GoTo OldApp
End Select

If compileOpt2 = "t" Then 'Parse file to get source
    ReadEXE = Crypt(Mid(FileData, InStr(1, FileData, "dpp:") + 4))
ElseIf compileOpt2 = "f" Then
    ReadEXE = Mid(FileData, InStr(1, FileData, "dpp:") + 4)
Else
    GoTo OldApp
End If

If compileOpt3 = "f" Then
    ReadEXE = "'Note: No source code found."
ElseIf compileOpt3 <> "t" Then
    GoTo OldApp
End If
     
If ReadEXE = "" Then ReadEXE = "'Note: No source code found."

a = InStr(1, ReadEXE, "begindpp>")
If a <> 0 Then
    ReadEXE = Mid(ReadEXE, a + 9)
End If

If Right(ReadEXE, 2) = "" Then
    ReadEXE = Left(ReadEXE, Len(ReadEXE) - 2)
End If

Exit Function

Error:
MsgBox "Error " & Err.Number & " has occured: " & Err.Description, vbCritical, "Error"
Exit Function

OldApp:
ReadEXE = Crypt(Mid(FileData, InStr(1, FileData, "dpp:") + 4))
MsgBox "The EXE you have opened was a valid D++ EXE, but was outdated.  The source code was found, however it may need to be uscrambled.  If the code appears unreadable, you can try to unscramble it by clicking View->Scramble.  To fix this problem, please recomple the EXE.", vbExclamation, "D++ IDE"
End Function
